---
# Master

- name: Проверить, существует ли каталог данных PostgreSQL
  ansible.builtin.stat:
    path: "{{ postgresql_data_directory }}"
  register: pg_data_dir

- name: Инициализировать PostgreSQL (если каталог данных отсутствует)
  ansible.builtin.command:
    cmd: /usr/lib/postgresql/15/bin/initdb -D {{ postgresql_data_directory }}
  become: yes
  become_user: postgres
  when: not pg_data_dir.stat.exists

- name: master | create postgresql.conf from template
  template:
    src: "{{ postgresql_templates_directory }}/{{ postgresql_postgresql_conf_template }}"
    dest: "{{ postgresql_configuration_directory }}/postgresql.conf"
    owner: "{{ postgresql_service_user }}"
    group: "{{ postgresql_service_group }}"
    mode: 0640
  notify:
    - restart postgresql

- name: Запустить PostgreSQL
  ansible.builtin.service:
    name: postgresql@15-main
    state: started
    enabled: yes


- name: master | Create users for replic
  community.postgresql.postgresql_user:
    name: "{{ item.name }}"
    password: "{{ item.password }}"
    role_attr_flags: "{{ item.role_attr_flags }}"
  loop: "{{ postgresql_users_replic }}"
  become: yes
  become_user: postgres
  no_log: true

- name: master | create postgresql users
  community.postgresql.postgresql_user:
    name: "{{ item.name }}"
    password: "{{ item.password }}"
    role_attr_flags: "{{ item.role_attr_flags }}"
    encrypted: "{{ item.encrypted }}"
    state: present
  loop: "{{ postgresql_users }}"
  when: postgresql_users is defined
  become: yes
  become_user: postgres
  no_log: true  

- name: master | create pg_hba.conf from template
  template:
    src: "{{ postgresql_templates_directory }}/{{ postgresql_pg_hba_template }}"
    dest: "{{ postgresql_configuration_directory }}/pg_hba.conf"
    owner: "{{ postgresql_service_user }}"
    group: "{{ postgresql_service_group }}"
    mode: 0640
  notify:
    - restart postgresql

- name: master | change config folder permissions
  file:
    path: "{{ postgresql_data_directory }}"
    owner: "{{ postgresql_service_user }}"
    group: "{{ postgresql_service_group }}"
    mode: 0750
    state: directory
  notify:
    - restart postgresql

- name: master | Перезапустить PostgreSQL
  ansible.builtin.systemd:
    name: postgresql
    state: started
    enabled: yes

- name: master | Force restart postgresql
  meta: flush_handlers
